//			~~~I STRONGLY encourage the modification and development of this free software by anyone to meet your needs, I only ask that you give me credit for the original work. Thanks and enjoy.~~~
"use strict";
this.author      = "Morgan Orr"; 
this.copyright   = "� 2011-2016 Morgan Orr."; 
this.licence = "CC-BY-SA 4.0";
this.version     = "1.2"; 
//I STRONGLY encourage the modification and development of this free software by all to meet your needs, I only ask that you give me credit for the original work. Thanks and enjoy!

/* version 1.2 modifed by Nick Rogers (phkb)
 - Cleaned up unnecessary lines in equipment.plist
 - Expanded text displayed if the player is discovered with a manifest scanner while doing a renovation.
 - included gov type 4 in all government checks
*/
"use strict"; 
this.author      = "Morgan Orr"; 
this.copyright   = "2014 Morgan Orr"; 
this.licence     = "CC-BY-SA 4.0";
this.version     = "1.2";

this.name        = "ManifestScannerEq";
this.description = "Equipment control script for the manifest scanner";

//restrict from mainstations communist-corprate systems
this.allowAwardEquipment = function(equipment, ship, context) {
	var p = player.ship;
	var stn = p.dockedStation;
	if (context == "purchase" && system.government >= 4 && stn.allegiance == "galcop") {
		return false;
	} else {
		return true;
	}
}

this.playerBoughtEquipment = function(equipment) {
	var p = player.ship;
	var stn = p.dockedStation;
	if( equipment === "EQ_MANIF_SCANNERX" ) {
		p.removeEquipment("EQ_MANIF_SCANNERX");
		p.removeEquipment("EQ_MANIF_SCANNER");
		var info = EquipmentInfo.infoForKey("EQ_MANIF_SCANNER");
		var refund = parseInt(((info.price / 10) * p.dockedStation.equipmentPriceFactor) * 0.9218);
		
		player.credits += refund; //2950
	}

	//Remove and fine if techies at mainstation find it in communist-corprate systems 
	if (equipment === "EQ_RENOVATION" && 
		system.government >= 4 && 
		stn.allegiance == "galcop" && 
		(p.equipmentStatus("EQ_MANIF_SCANNER") == "EQUIPMENT_OK" || p.equipmentStatus("EQ_MANIF_SCANNER") == "EQUIPMENT_DAMAGED")) {

		this._scannerRemove = true;
		mission.runScreen({
			title: "Suspicious Activity", 
			message: "It appears that some of your equipment has been tampered with.", 
			model:"station"}
		);
	}
}

this.missionScreenOpportunity= function() {
	if(this._scannerRemove) {
    	this._scannerRemove = false;
        mission.runScreen({
			title: "Equipment Confiscated", 
			message: "Your Manifest Scanner has been confiscated as per GalCop regulation GC-149874-2 which states:" + 
			"\n\n'Devices designed to scan a ship's manifest while in space, operating in unauthorised vessels, are deemed to be illegal. " + 
			"Should such a device be discovered on a ship by a GalCop official in any capacity (be it law enforcement or engineering), it will be removed and destroyed.'" + 
			"\n\nWe would normally issue a fine for this offence, but decided that a warning was sufficient. Please take care to obey GalCop laws in future.", 
			model: "police"
		});
		player.ship.removeEquipment("EQ_MANIF_SCANNER");
    }
}




